(* PROGRAMMING EXERCISES 1 *)

(* Questions to Marco Kuhlmann <kuhlmann@coli.uni-sb.de> *)


(* Exercise 1: Binding variables to values *)

(* a *)

val x = 42
val y = 21
val z = x*y

(* b *)

val x = 4711
val y = "foo"
val z = x*y

(* In binding z, we try to multiply a value of type int with a
 * value of type string. This is impossible. *)

(* c *)

(* x has value 4711 and type int
 * y has value "foo" and type string
 * z has value 882 and type int *)


(* Exercise 2: Functions *)

(* a *)

fun add (x,y) = x+y

(* b *)

fun max (x,y) = if x>y then x else y

(* c *)

(* add and max both have type int * int -> int. That means: They
 * take as input a pair of integers and return an integer. *)


(* Exercise 3: Lists *)

(* a *)

val xs = ["foo","bar","baz"]

(* b *)

val ys = [x,y,x*y]

(* c *)

val zs = xs @ ys

(* zs cannot be assigned a type: all the elements of a list must
 * have the same type, but xs contains strings, and ys contains
 * integers. *)


(* Exercise 4: Functions on lists *)

(* a *)

fun listsum []      = 0
  | listsum (x::xs) = x + listsum xs

(* b *)

fun count (e,[])      = 0
  | count (e,(x::xs)) = if e=x then 1 + count e xs else count e xs


(* Exercise 5: Abstractions *)

(* a *)

val add = fn x => (fn y => x+y)

(* b *)

val max = fn x => (fn y => if x>y then x else y)


(* Exercise 6: All in a nutshell *)

(* a *)

fun map f []      = []
  | map f (x::xs) = (f x)::(map f xs)

(* b *)

fun foldl f e []      = e
  | foldl f e (x::xs) = foldl f (f(x,e)) xs

(* c *)

val listsum = foldl (fn (x,e) => x+e) 0
