open Set
open Dictionary

type ''a universe = ''a set

type ''a predicate = ''a set

type ''a modeltype = (''a universe * (''a,''a set) dictionary)

type ''a model = ''a modeltype ref

fun NewModel() = ref (empty,new()) 

fun AddObject (m as ref(u,p),s) = m := (add(u,s),p)

fun DeleteObject (m as ref(u,p),s) = m := (diff(u,singleton(s)),p)
       
fun ShowObjects (m as ref(u,_)) = toList(u)
	
fun NewProperty (m as ref(u,p),s) = (insert(p,s,empty);
				     m := (u,p))
	
fun AddToProperty (m as ref(u,p),s,item) = ( if not(member(p,s)) 
					     then NewProperty(m,s)
					     else ();
					     insert(p,s,add(lookup(p,s),item));
					     m := (u,p))

fun DeleteFromProperty (m as ref(u,p),s,item) = ( if member(p,s)
						  then insert(p,s,diff(lookup(p,s),singleton(item)))
						  else ();
						  m := (u,p))

fun HasProperty (m as ref(u,p),s,item) = if member(p,s) 
					 then elementOf(lookup(p,s),item)
					 else false

fun ShowProperty (m as ref(u,p),s) = if member(p,s)
				     then toList(lookup(p,s))
				     else nil







