(*
 * $Id: Lexicon.sig,v 1.5 2001/06/07 09:51:28 kuhlmann Exp $
 *
 * Lexicon
 *
 * Authors: Marco Kuhlmann <mk@picoli.com>
 *
 *)

type lexicon

datatype cat = ADJ | DET | CN | P | PN | VI | VT | VINF

type tag = String.string * cat

(* create an empty lexicon *)
val new : lexicon

(* add a word to the lexicon, and assign it a category *)
val add : lexicon -> string -> cat -> lexicon

(* return the list of tags for a given word *)
val tag : lexicon -> string -> (tag list) option

(* return true iff word is member of the lexicon *) 
val member : lexicon -> string -> bool
