(*
 * $Id: Parser.sig,v 1.4 2001/06/07 09:51:28 kuhlmann Exp $
 *
 * Signature for the Naive Parser
 *
 * Authors: Marco Kuhlmann <mk@picoli.com>
 *
 *)

exception Parser

(* datatype for syntactic categories *)
datatype SCat = S | NP | PP | Q | VP | LEX of Lexicon.cat

(* datatype for syntax trees *)
datatype STree = N of Lexicon.tag | B of SCat * STree list

(* how a syntactic rule looks like *)
type rule = {cat : SCat, subcat : SCat list}

(* given a lexicon and a list of rules, transform a string into
 * the list of possible syntax trees *)
val parse : Lexicon.lexicon -> rule list -> string -> STree list

(* prettyprinter *)
val pp : STree list -> unit
