(* Sebastian Pado
   Model-theoretic semantics: a structure (sigma-algebra)
   25.05.01 *)

type prop   (* Property *)
type model  (* Model *)
  
type entry = stringset.entry

exception NotInModel

val newModel : int -> model (* Size *) 
val newProperty: model -> prop -> unit
val existsProperty: model -> prop -> bool
val addToProperty: model -> entry -> prop -> unit
val delFromProperty: model -> entry -> prop -> unit
val hasProperty: model -> entry -> prop -> bool
val getAllProperties: model -> prop list
val getAllWithProperty: model -> prop -> entry list

val toProp: string -> prop
val fromProp: prop -> string

val pp: model -> unit