
type SCat = Parser.SCat

type STree = Parser.STree

type entry = model.entry

(* Quantifikation *)

datatype Quant = QNone | Forall | Exists

(* Bedeutung einer Nominalphrase *)

datatype NPSem = PN of {name: string, mod: PPSem} |
	       	 NP of {head: string, quant: Quant, 
			mod: PPSem}

(* Semantik eines Prdikats *)

and PredSem = VERBP of {pred: string} |
              ADJP  of {pred: string} |
	      NPP   of NPSem

(* Bedeutung einer Propositionalphrase *)

and PPSem = PNone | With of NPSem

(* Bedeutung einer Verbalphrase *)

and VPSem = VPIS of {pred: PredSem, question: bool, mod: PPSem} |
    VPTRANS of {pred: PredSem, obj: NPSem, question: bool, mod: PPSem} |
    VPINTRANS of {pred: PredSem, question: bool, mod: PPSem}

(* Bedeutung eines Satzes *)

and SentSem = IS of {pred: PredSem, subj: NPSem, question: bool, 
		     mod: PPSem} |
              TRANS of {pred: PredSem, subj: NPSem, 
                        obj: NPSem, question: bool, mod: PPSem} |
	      INTRANS of {pred: PredSem, subj: NPSem, 
			  question: bool, mod: PPSem}

