(*
 * $Id: set-sig.sml,v 1.2 2001/05/27 15:14:47 pado Exp $
 *
 * Signature for Sets
 *
 * Authors:  Marco Kuhlmann <mk@picoli.com>
 *
 *)

signature SET =
  sig
    type item
    type set
    val empty        : set
    val isEmpty      : set -> bool
    val singleton    : item -> set
    val add          : set -> item -> set
    val member       : set -> item -> bool
    val map          : (item -> item) -> set -> set
    val union        : set -> set -> set
    val intersection : set -> set -> set
    val difference   : set -> set -> set
    val foldl        : (item * 'a -> 'a) -> 'a -> set -> 'a 
    val toList       : set -> item list
    val filter       : (item -> bool) -> set -> set
  end
