(*
 * $Id: string-aux-sig.sml,v 1.1 2001/05/29 17:59:47 kuhlmann Exp $
 *
 * Auxiliary Functions on Strings (Signature)
 *
 * Authors: Marco Kuhlmann <mk@picoli.com>
 *
 *)

signature STRING_AUX =
  sig

    (* test whether a string is empty *)
    val isEmpty : string -> bool

    (* return the first character of a string *)
    val first   : string -> char                                 (* Subscript *)

    (* return the last character of a string *)
    val last    : string -> char                                 (* Subscript *)

    (* return a string without is last letter *)
    val prefix  : string -> string                               (* Subscript *)

    (* return a string without is first letter *)
    val suffix  : string -> string                               (* Subscript *)

    (* map a function over a list and concatenate the results *)
    val smap    : ('a -> string) -> 'a list -> string

  end