(*
 * $Id: string-aux.sml,v 1.1 2001/05/29 17:57:57 kuhlmann Exp $
 *
 * Auxiliary Functions on Strings
 *
 * Authors: Marco Kuhlmann <mk@picoli.com>
 *
 *)

structure StringAux : STRING_AUX =
  struct

    (* test whether s is empty *)
    fun isEmpty s = String.size(s) = 0

    (* return the first character of s *)
    fun first s = String.sub(s,0)

    (* return the last character of s *)
    fun last s = String.sub(s,String.size(s)-1)

    (* return s without its last letter *)
    fun prefix s = String.extract(s,0,SOME(String.size(s)-1))

    (* return s without is first letter *)
    fun suffix s = String.extract(s,1,NONE)

    (* map (f : 'a -> string) over an 'a list and concatenate the results *)
    fun smap f nil     = ""
      | smap f (x::xs) = (f x) ^ (smap f xs)

  end
