(*
 * Signature for Model Entry Sets
 *
 * Authors:  Sebastian Pado
 *
 * 27.05.01
 *)

type set

datatype entry = UNARY of string | BINARY of string * string

val empty        : set
val isEmpty      : set -> bool
val singleton    : entry -> set
val add          : set -> entry -> set
val remove       : set -> entry -> set
val member       : set -> entry -> bool
val map          : (entry -> entry) -> set -> set
val union        : set -> set -> set
val intersection : set -> set -> set
val difference   : set -> set -> set
val foldl        : (entry * 'a -> 'a) -> 'a -> set -> 'a 
val toList       : set -> entry list
val filter       : (entry -> bool) -> set -> set


